=== debian/changelog ===
znc (1.7.0-1) unstable; urgency=high

  * New upstream release.
    - Switch to Tcl 8.6.
      Closes: #820517
    - Support separate key and certificate files.
      Closes: #861003
    - Add new modules.
  * Adjust debian/copyright.
  * Bump Standards-Version to 4.1.4.
  * Bump debian/compat to level 11.
  * Install NOTICE file.

 -- Patrick Matthäi <pmatthaei@debian.org>  Mon, 07 May 2018 16:09:51 +0200
