=== debian/changelog ===
znc (1.7.1-2ubuntu0.2) cosmic-security; urgency=medium

  * SECURITY UPDATE: Fix vulnerability that allows remote authenticated
    non-admin users to escalate privileges and execute arbitrary code by
    loading a module with a crafted name.
    - debian/patches/CVE-2019-12816.patch: Fix remote code execution and
      privilege escalation.
    - CVE-2019-12816

 -- Paulo Flabiano Smorigo <pfsmorigo@canonical.com>  Tue, 25 Jun 2019 15:51:49 -0300

znc (1.7.1-2ubuntu0.1) cosmic-security; urgency=medium

  * SECURITY UPDATE: Fix DoS while using an invalid encoding (LP: #1821760)
    - debian/patches/CVE-2019-9917.patch: Don't crash if user specified invalid
      encoding.
    - CVE-2019-9917

 -- Paulo Flabiano Smorigo <pfsmorigo@canonical.com>  Mon, 08 Apr 2019 10:56:22 -0300

znc (1.7.1-2) unstable; urgency=high

  * Change znc-dev Tcl dependency to tcl-dev.
    Closes: #896087

 -- Patrick Matthäi <pmatthaei@debian.org>  Mon, 13 Aug 2018 11:51:06 +0200

znc (1.7.1-1) unstable; urgency=high

  * New upstream release.
    - Fixes privilege escalation by injecting rogue values in znc.conf as
      described in CVE-2018-14055.
      Closes: #903787
    - Fixes path traversal as described in CVE-2018-14056.
      Closes: #903788
  * Bump Standards-Version to 4.1.5.
  * Merge 1.6.5-1+deb9u1 changelog.
  * Apply patch from Unit193 to enable tests at build time.
    Closes: #898364
  * Adjust lintian overrides.
  * Move pkgconfig znc.pc file to multiarch directory.

 -- Patrick Matthäi <pmatthaei@debian.org>  Wed, 18 Jul 2018 10:01:05 +0200

znc (1.6.5-1+deb9u1) stretch-security; urgency=high

  * Add patch 01-CVE-2018-14056 to fix a path traversal flaw as described in
    CVE-2018-14056.
    Closes: #903788
  * Add patch 02-CVE-2018-14055 to fix a privilege escalation by injecting
    rogue values in znc.conf as described in CVE-2018-14055.
    Closes: #903787

 -- Patrick Matthäi <pmatthaei@debian.org>  Tue, 17 Jul 2018 09:34:40 +0200
