=== debian/control ===
--- 
+++ 
@@ -10,10 +10,13 @@
  tcl-dev,
  libsasl2-dev,
  swig3.0,
+ google-mock,
+ googletest,
  dh-python,
  python3-dev
-Maintainer: Patrick Matthäi <pmatthaei@debian.org>
-Standards-Version: 4.1.4
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Patrick Matthäi <pmatthaei@debian.org>
+Standards-Version: 4.1.5
 Homepage: https://www.znc.in/
 
 Package: znc
@@ -48,7 +51,7 @@
  libssl-dev,
  libperl-dev,
  pkg-config,
- tcl8.5-dev,
+ tcl-dev,
  libsasl2-dev,
  python3-dev
 Recommends: g++
