## znc 1.7.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -15,8 +15,8 @@
 #
 
 cmake_minimum_required(VERSION 3.1)
-project(ZNC VERSION 1.7.1)
-set(ZNC_VERSION 1.7.1)
+project(ZNC VERSION 1.7.2)
+set(ZNC_VERSION 1.7.2)
 set(append_git_version false)
 set(alpha_version "") # e.g. "-rc1"
 set(VERSION_EXTRA "" CACHE STRING
