=== debian/changelog ===
znc (1.7.2-3~bpo9+1) stretch-backports; urgency=medium

  * Rebuild for stretch-backports.

 -- Mattia Rizzolo <mattia@debian.org>  Tue, 18 Jun 2019 09:48:15 +0200

znc (1.7.2-3) unstable; urgency=high

  * Add upstream patch CVE-2019-12816 to fix a remote code execution by
    elevating privileges as described in CVE-2019-12816.

 -- Patrick Matthäi <pmatthaei@debian.org>  Fri, 14 Jun 2019 11:14:11 +0200

znc (1.7.2-2) unstable; urgency=high

  * Add upstream patch 01-CVE-2019-9917 to fix a crash on invalid encoding,
    which fixes CVE-2019-9917.
    Closes: #925285

 -- Patrick Matthäi <pmatthaei@debian.org>  Tue, 26 Mar 2019 12:46:42 +0100

znc (1.7.2-1) unstable; urgency=medium

  * New upstream release.
  * Bump Standards-Version to 4.3.0.
  * Remove useless dh_auto_build and dh_auto_install overriding.
    Closes: #914777
  * Bump debian/compat to level 12.
  * Switch to dh_missing.
  * Install admindebug module.

 -- Patrick Matthäi <pmatthaei@debian.org>  Mon, 28 Jan 2019 10:44:26 +0100
