=== debian/control ===
--- 
+++ 
@@ -1,7 +1,7 @@
 Source: znc
 Section: net
 Priority: optional
-Build-Depends: debhelper (>= 11),
+Build-Depends: debhelper (>= 12),
  libssl-dev,
  libperl-dev,
  libicu-dev,
@@ -14,9 +14,8 @@
  googletest,
  dh-python,
  python3-dev
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Patrick Matthäi <pmatthaei@debian.org>
-Standards-Version: 4.1.5
+Maintainer: Patrick Matthäi <pmatthaei@debian.org>
+Standards-Version: 4.3.0
 Homepage: https://www.znc.in/
 
 Package: znc
